
#include <stdlib.h>
#include "typeinfo.h"

SCALAR_TYPE* allocate_strip(int nx) {
	return (SCALAR_TYPE*) malloc(sizeof(SCALAR_TYPE) * nx);
}

SCALAR_TYPE** allocate_plane(int nx, int ny) {
	SCALAR_TYPE** data_plane = (SCALAR_TYPE**) malloc(sizeof(SCALAR_TYPE*) * ny);
	int ny_counter;
	
	for(ny_counter = 0; ny_counter < ny; ny_counter++) {
		data_plane[ny_counter] = allocate_strip(nx);
	}
	
	return data_plane;
}

SCALAR_TYPE*** allocate_data_block(int nx, int ny, int nz) {
	SCALAR_TYPE*** data_block = (SCALAR_TYPE***) malloc(sizeof(SCALAR_TYPE*) * nz);
	int nz_counter;
	
	for(nz_counter = 0; nz_counter < nz; nz_counter++) {
		data_block[nz_counter] = allocate_plane(nx, ny);
	}
	
	return data_block;
}

SCALAR_TYPE**** allocate_data(int num_vars, int nx, int ny, int nz) {
	SCALAR_TYPE****	data_array = (SCALAR_TYPE****) malloc(sizeof(SCALAR_TYPE*) * num_vars);
	int var_counter;
	
	for(var_counter = 0; var_counter < num_vars; var_counter++) {
		data_array[var_counter] = allocate_data_block(nx+2, ny+2, nz+2);
	}
	
	return data_array;
}