
#include "typeinfo.h"

void stencil_3d27pt(SCALAR_TYPE**** data,
	SCALAR_TYPE**** result,
	int num_vars, int nx, int ny, int nz) 
{
	int v_counter, z_counter, y_counter, x_counter = 0;

	for(v_counter = 0; v_counter < num_vars; v_counter++) {
		for(z_counter = 1; z_counter <= nz; z_counter++) {
			for(y_counter = 1; y_counter <= ny; y_counter++) {
				for(x_counter = 1; x_counter <= nx; x_counter++) {
					result[v_counter][z_counter][y_counter][x_counter] =
					( 
							data[v_counter][z_counter - 1][y_counter - 1][x_counter - 1] +
							data[v_counter][z_counter - 1][y_counter - 1][x_counter] +
							data[v_counter][z_counter - 1][y_counter - 1][x_counter + 1] +
						
							data[v_counter][z_counter - 1][y_counter][x_counter - 1] +
							data[v_counter][z_counter - 1][y_counter][x_counter] +
							data[v_counter][z_counter - 1][y_counter][x_counter + 1] +
							
							data[v_counter][z_counter - 1][y_counter + 1][x_counter - 1] +
							data[v_counter][z_counter - 1][y_counter + 1][x_counter] +
							data[v_counter][z_counter - 1][y_counter + 1][x_counter + 1] +
							
						  	data[v_counter][z_counter][y_counter - 1][x_counter - 1] +
							data[v_counter][z_counter][y_counter - 1][x_counter] +
							data[v_counter][z_counter][y_counter - 1][x_counter + 1] +
						  	
						  	data[v_counter][z_counter][y_counter][x_counter - 1] +
							data[v_counter][z_counter][y_counter][x_counter] +
							data[v_counter][z_counter][y_counter][x_counter + 1] +
							
							data[v_counter][z_counter][y_counter + 1][x_counter - 1] +
							data[v_counter][z_counter][y_counter + 1][x_counter] +
							data[v_counter][z_counter][y_counter + 1][x_counter + 1] +
							
							data[v_counter][z_counter + 1][y_counter - 1][x_counter - 1] +
							data[v_counter][z_counter + 1][y_counter - 1][x_counter] +
							data[v_counter][z_counter + 1][y_counter - 1][x_counter + 1] +
							
							data[v_counter][z_counter + 1][y_counter][x_counter - 1] +
							data[v_counter][z_counter + 1][y_counter][x_counter] +
							data[v_counter][z_counter + 1][y_counter][x_counter + 1] +
							
							data[v_counter][z_counter + 1][y_counter + 1][x_counter - 1] +
							data[v_counter][z_counter + 1][y_counter + 1][x_counter] +
							data[v_counter][z_counter + 1][y_counter + 1][x_counter + 1]
					) / 27.0;
				}
			}
		}
	}
}

void stencil_2d9pt(SCALAR_TYPE**** data,
	SCALAR_TYPE**** result,
	int num_vars, int nx, int ny, int nz) 
{
	int v_counter, z_counter, y_counter, x_counter = 0;

	for(v_counter = 0; v_counter < num_vars; v_counter++) {
		for(z_counter = 1; z_counter <= nz; z_counter++) {
			for(y_counter = 1; y_counter <= ny; y_counter++) {
				for(x_counter = 1; x_counter <= nx; x_counter++) {
					result[v_counter][z_counter][y_counter][x_counter] =
					( 
						  	data[v_counter][z_counter][y_counter - 1][x_counter - 1] +
							data[v_counter][z_counter][y_counter - 1][x_counter] +
							data[v_counter][z_counter][y_counter - 1][x_counter + 1] +
						  	
						  	data[v_counter][z_counter][y_counter][x_counter - 1] +
							data[v_counter][z_counter][y_counter][x_counter] +
							data[v_counter][z_counter][y_counter][x_counter + 1] +
							
							data[v_counter][z_counter][y_counter + 1][x_counter - 1] +
							data[v_counter][z_counter][y_counter + 1][x_counter] +
							data[v_counter][z_counter][y_counter + 1][x_counter + 1] 
					) / 9.0;
				}
			}
		}
	}
}